/// \file
/// {COMMON_HEADER}
///
/// \section DESCRIPTION
/// This header files containts constants for the VectorNav C++ Math Library.
#ifndef _VN_MATH_CONSTS_H_
#define _VN_MATH_CONSTS_H_

namespace vn {
namespace math {

/// \defgroup pi_constants PI Constants
/// \brief Convenient PI constants.
/// \{

/// \brief PI in single-precision.
static const float PI = 3.141592653589793238f;

/// \brief PI in single-precision.
static const float PIf = PI;

/// \brief PI in double-precision.
static const double PId = 3.141592653589793238;

/// \brief PI * 2 in single-precision.
static const float PI2 = 6.283185307179586476f;

/// \brief PI * 2 in single-precision.
static const float PI2f = PI2;

/// \brief PI * 2 in double-precision.
static const double PI2d = 6.283185307179586476;

/// \brief PI / 2 in single-precision.
static const float PIH = 1.570796326794896619f;

/// \brief PI / 2 in single-precision.
static const float PIHf = PIH;

/// \brief PI / 2 in double-precision.
static const double PIHd = 1.570796326794896619;

/// \}

}
}

#endif
